package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.AflnetProperties;
import com.example.fuzzControll.exception.MysqlException;
import com.example.fuzzControll.mapper.AflnetMapper;
import com.example.fuzzControll.pojo.vo.AflnetResult;
import com.example.fuzzControll.pojo.vo.KittyResult;
import com.example.fuzzControll.service.AflnetPersistenceService;
import com.example.fuzzControll.tools.FileTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service("AflnetPersistenceService")
public class AflnetPersistenceServiceImpl implements AflnetPersistenceService {
    @Autowired
    AflnetMapper aflnetMapper;
    @Autowired
    AflnetProperties aflnetProperties;
    FileTools fileTools = new FileTools();

    @Override
    public int aflnetResultBackup(String filename) {
        //todo 需要传入任务id
        AflnetResult result = new AflnetResult(1, fileTools.fileReadAndTranstoBytes(aflnetProperties.getOutputPath(),filename), filename);
        return aflnetMapper.aflnetOutputBackup(result);
    }

    @Override
    public void loadInFile(int missionId, String filePath) {
        AflnetResult aflnetResult = null;
        try {
            aflnetResult = aflnetMapper.selectResultById(missionId);
        } catch (MysqlException e) {
            e.printStackTrace();
            throw new MysqlException("AflnetMapper.selectResultById() Error!");
        }
        fileTools.loadFileInLocal(filePath, aflnetResult.getFileName(),aflnetResult.getFile());
    }

}
